/****************************************************************************/
/* T  vFt@CVXe AvP[VC^tF[X					*/
/*   F																	*/
/* 쐬F	2005.03.06														*/
/* XVF	2009.01.03														*/
/* Copyright	resove 														*/
/****************************************************************************/
#ifndef RF_INTERFACE_H
#define RF_INTERFACE_H

#include "RfDriverInterface.h"
#include "RfDiskLayout.h"
#include "RfErrCode.h"

/* T_SEARCH_DIR  cond ɓl */
#define	RF_ENTRY_VALID		( 0 )						/* LȃGg	*/
#define	RF_ENTRY_FREE		( 1 )						/* gpGg	*/
#define	RF_ENTRY_NOT_FOUND	( 2 )						/* Ō܂ŒTȂ	*/
#define	RF_ENTRY_TERMINATE	( 3 )						/* Gg̏I[ɒB		*/
#define	RF_ENTRY_ERR_ACCESS	( 4 )						/* ǂݍ݃G[		*/

/* fBNg폜 */
typedef struct t_rf_del_dir
{
	unsigned long	entryAddr;				/* fBNg̐efBNg̃GgAhX		*/
	unsigned short	firstCluster;			/* fBNgf[^̃NX^ԍ	*/
	unsigned short	nest;					/* lXg						*/
} T_RF_DEL_DIR;

/* t@C폜 */
typedef struct t_rf_del_file
{
	unsigned long	entryAddr;				/* ̃GgAhX		*/
	unsigned short	firstCluster;			/* t@CNX^ԍ			*/
} T_RF_DEL_FILE;

typedef struct t_rf_search {
	unsigned long entryAddr;					/* fBNgGgAhX*/
	unsigned short curCluster;					/* ݂̃NX^ԍ		*/
	unsigned short firstCluster;				/* 擪NX^				*/
	unsigned long pointInCluster;				/* NX^̈ʒu			*/
	unsigned long totalLen;						/* t@C				*/
	unsigned long curPoint;						/* 擪̃oCgʒu		*/
	unsigned char attribute;					/* 						*/
	unsigned char fill;							/* 						*/
} T_RF_SEARCH;

typedef struct t_rf_search_dir {
	unsigned long entryAddr;					/* fBNgGgAhX*/
	unsigned short curCluster;					/* ݂̃NX^ԍ		*/
	unsigned short firstCluster;				/* 擪NX^				*/
	unsigned long pointInCluster;				/* NX^̈ʒu			*/
	unsigned short cond;						/* fBNg		*/
	unsigned short fill;						/* 						*/
	unsigned long  fill2;						/* (2)					*/
	unsigned char attribute;					/* 						*/
	char          flNameTop;					/* t@C̐擪		*/
} T_RF_SEARCH_DIR;

/* t@CRg[ubN */
typedef struct t_rf_fcb {
	union {
		T_RF_SEARCH		sr;						/* t@C read/write		*/
		T_RF_SEARCH_DIR	sd;						/* fBNgp		*/
		T_RF_DEL_DIR	dd;						/* fBNg폜p		*/
		T_RF_DEL_FILE	df;						/* t@C폜p			*/
	} brk;
	unsigned char canWriteFlag:1;				/* write \tO			*/
	unsigned char canReadFlag:1;				/* read  \tO			*/
	unsigned char useFlag:1;					/* gp敪tO			*/
	unsigned char openMode;						/* I[ṽ[h			*/
} T_RF_FCB;


/* ̌^ */
typedef struct t_rf_time {
	unsigned short year;						/* N */
	unsigned short month;						/*  */
	unsigned short day;							/*  */
	unsigned short hour;						/*  */
	unsigned short min;							/*  */
	unsigned short sec;							/* b */
	unsigned short mSec;						/* ~b */
} T_RF_TIME;

/* fBNg̃[h */
typedef struct t_fr_dir_info {
	T_RF_TIME	timeCreate;						/* 쐬tA		*/
	T_RF_TIME	timeAccess;						/* ŏIANZXt		*/
	T_RF_TIME	timeUpdate;						/* XVtA		*/
	unsigned long size;							/* t@CTCY		*/
	unsigned char attribute;					/* 					*/
	char		name[13];						/* t@C			*/
} T_RF_DIR_INFO;


/* hCȕ 															*/
/* 敪ɂ														*/
/* ǂ܂ŏ											*/
/* IvVɂĂ͊SɏȂȂĂ format ȂB	*/
/* formatɂ̋敪𔻒肵IvV`FbNB						*/
/*																			*/
/* drvInit: fBXNTCYAubNTCY擾ł						*/
/*           MBR쐬 format ȂƂł				*/
/*																			*/
/* mbrInit: MBR 擾ł												*/
/*           BPB ̈ʒułĂ̂ BPB ̈ʒuwȂ format 	*/
/*          ȂƂłB										*/
/*																			*/
/* bpbInit: BPB 擾ł												*/
/*           NX^TCYwȂ format ȂB					*/
typedef struct t_rf_drive_info 
{
	char			fSystem;							/* t@CVXe(FAT12/FAT16)*/
	unsigned char	sectorPerCluster;					/* NX^̃ZN^			*/
	unsigned short	bytesPerSector;						/* ZN^oCg				*/
	unsigned long	bytesPerCluster;					/* NX^̃oCg			*/
	unsigned long	cardSize;							/* J[hŜ̃oCg			*/
	unsigned long	bpbSector;							/* BPB ̊JnZN^				*/
	unsigned long	fatPoint;							/* FAT ̊JnAhX			*/
	unsigned long	fatSize;							/* 1FAT ̃oCg				*/
	unsigned short	fatNum;								/* FAT 						*/
	unsigned short	clusterNum;							/* SNX^					*/
	unsigned long	rootPoint;							/* ROOT fBNg̊JnAhX	*/
	unsigned short	rootEntryNum;						/* ROOT fBNg̃Gg*/
	unsigned long	bodyPoint;							/* body ̊JnAhX			*/
	unsigned char	drvInit:1;							/* Iȏ敪	*/
	unsigned char	mbrInit:1;							/* MBR 擾ł敪			*/
	unsigned char	bpbInit:1;							/* BPB 擾ł敪			*/
} T_RF_DRIVE_INFO;

/* fSystem ̓e */
#define RF_F_SYSTEM_UNKNOWN		( (char)0 )
#define RF_F_SYSTEM_FAT12		( (char)1 )				/* FAT12					*/
#define RF_F_SYSTEM_FAT16		( (char)2 )				/* FAT16					*/


/* RfInitFileSystem() ̈ */
typedef struct t_rf_system_function {
	unsigned short (*pGetNowTime)(T_RF_TIME* time);			/* ݎ擾֐			*/
	unsigned short (*pUnicodeToAscii)(
							   unsigned short * uniStr,
							   unsigned short uniLen,
							   unsigned char * asciiStr );	/* UNICODE  ASCII ɕϊ */
	unsigned short (*pAsciiToUnicode)(
							   unsigned char * asciiStr,
							   unsigned short asciiLen,
							   unsigned short * uniStr );	/* ASCII  UNICODE ɕϊ */
} T_RF_SYSTEM_FUNCTION;


/* I[ṽ[h */
/* ꂼPƂŎw肷邩 											*/
/* RF_OPEN_READ Ƃ̑ WRITE [hgݍ킹Ďgp邱Ƃł */

#define RF_OPEN_READ			( (unsigned char)1 )	/* ǂݎp	*/
														/* t@C݂Ȃ̓G[ƂȂ		*/
#define RF_OPEN_WRITE_NEW		( (unsigned char)2 )	/* ݗpŐVKɍ쐬				*/
														/* file ݂鎞̓G[ƂȂ			*/
														/* file ݂Ȃ͐VKɍ쐬		*/
#define RF_OPEN_WRITE_CREATE	( (unsigned char)4 )	/* ݗpŏɐ					*/
														/* file ݂鎞͎n߂ɃTCY 0 Ƃ*/
														/* file ݂Ȃ͐VKɍ쐬		*/
#define RF_OPEN_WRITE_OLD		( (unsigned char)8 )	/* łɑ݂t@CݗpɃI[v*/
														/* file ݂ĂTCY 0 ɂȂ		*/
														/* file ݂Ȃ̓G[ƂȂ		*/
#define RF_OPEN_OPT_SEQ			( (unsigned char)16 )	/* V[PVANZXɓœK	*/
														/* ȂB								*/

/* ygݍ킹̓z														*/
/* RF_OPEN_READ | RF_OPEN_WRITE_NEW												*/
/* ݂t@Cw肵̓G[ƂȂ 									*/
/* ݂Ȃt@Cw肵̓t@CVKɍ쐬						*/
/* Write セ̕ǂނƂł										*/

/* RF_OPEN_READ | RF_OPEN_WRITE_CREATE											*/
/* ݂t@Cw肵̓TCY 0 ɂĂJn					*/
/* ݂Ȃt@Cw肵͐VKɍ쐬								*/
/* Write セ̕ǂނƂł										*/
	
/* RF_OPEN_READ | RF_OPEN_WRITE_OLD												*/
/* ݂t@Cw肵͎n߂ɑ݂TCŶ܂܊Jn				*/
/* ݂Ȃt@Cw肵̓G[ƂȂ									*/

/* yRF_OPEN_OPT_SEQFV[PVANZXɓœKz					*/
/* @read AZN^̍Ō܂œǂݏIƎ̃ZN^readN			*/
/* Awrite AZN^̍ŌނƂ̃ZN^writeN				*/
/* Bwrite A̓e͓ǂݎȂBׂď㏑݂̏ƂȂB			*/
/* Cseek gpƌB											*/
/* Dread  write ̑gݍ킹ƓɎgpĂ͂ȂB						*/
/* EhCoɓǂݏ̃LbNƐĩ|[OȂ@\邱ƁB*/
/*   hCo@\ȂꍇAG[Ƃ͂ȂœKꂽ͂	*/
/*   ȂȂB																	*/
/*																				*/
/*    read ŃZN^܂ꍇ͍œK͂ȂȂB				*/

#define RF_OPEN_DIR		((unsigned char) 128)	/* fBNgI[v 	*/

/* seek  origin */
#define RF_SEEK_SET					( 1 )				/* 擪ʒuw	*/
#define RF_SEEK_END					( 2 )				/* I[ʒuw	*/
#define RF_SEEK_CUR					( 3 )				/* ݈ʒuʒuw	*/

/* o[W */
typedef struct t_rf_sys_ver {
	unsigned short fsys;								/* t@CVXẽo[W */
	T_RF_DRV_VER drv;									/* hCõo[W			*/
} T_RF_FSYS_VER;

/* obt@ǗubN */
/* justReadFlag ĂԂ̓obNOEhœǂݎ肪			*/
/* 삵Ă邱ƂӖBl justWriteFlag ͏ݒB		*/
/* ̍ۂɂ completeSize Ɋi[B				*/
/* ׂĊ completeSize  buffSize ȂB				*/
typedef struct t_rf_file_buff {
	unsigned long cardAddr;						/* foCX̃AhX */
	char * buffAddr;							/* obt@AhX		*/
	unsigned short buffSize;					/* obt@TCY		*/
	unsigned short completeSize;				/* XV̊TCY	*/
	unsigned char useFlag:1;					/* gptO			*/
	unsigned char updateFlag:1;					/* XVtO			*/
	unsigned char justReadFlag:1;				/* ǂݎ蒆tO		*/
	unsigned char justWriteFlag:1;				/* ݒtO		*/
	unsigned char fill;							/* 					*/
} T_RF_FILE_BUFF;

/********************************************************/
/* ֐^錾											*/
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif
/*--------------------------------------*/
/* Ǘ@\								*/
/*--------------------------------------*/
/* t@CVXȅ */
unsigned short RfInitFileSystem( void );
/* t@CVXe̊ */
unsigned short RfConclude( void );
/* hCu擾 */
unsigned short RfGetDriveInfo( T_RF_DRIVE_INFO * pDriveInfo );

/*--------------------------------------*/
/* read/write @\						*/
/*--------------------------------------*/
/* I[v */
T_RF_FCB * RfOpen( char * fileName, unsigned short mode, unsigned short * err );
/*  */
unsigned short RfWrite( T_RF_FCB * pFcb, char * pBuff, unsigned long * pLen );
/* ǂݍ */
unsigned short RfRead( T_RF_FCB * pFcb, char * pBuff, unsigned long * pLen );
/* ǂݏ̈ʒuς */
unsigned short RfSeek( T_RF_FCB * pFcb, long offset, unsigned short origin );
/* obt@̃f[^ */
unsigned short RfFlush( T_RF_FCB * pFcb );
/* t@CTCY擾 */
unsigned short RfGetSize( T_RF_FCB * pFcb, unsigned long * size );
/* t@C̃N[Y */
unsigned short RfClose( T_RF_FCB * pFcb );

/*--------------------------------------*/
/* t@\								*/
/*--------------------------------------*/
/* fBNg */
unsigned short RfMkDir( char * fileName );
/* t@C폜 */
unsigned short RfDelFile( char * fileName );
/* fBNg폜 */
unsigned short RfDelDir( char * fileName );
/* t@Cړ */
unsigned short RfMove( char * dirName, char * fileName );
/* t@C̓ǂݎp𑀍삷 */
unsigned short RfSetReadOnly( char * fileName, unsigned short add );
/* t@CVXẽo[W擾 */
unsigned short RfGetVerSion( T_RF_FSYS_VER * fsysVer );
/* fBNgI[v */
T_RF_FCB * RfOpenDir( char * fileName, unsigned short * pErr );
/* fBNgǂ */
unsigned short RfReadDir( T_RF_FCB * pFcb, T_RF_DIR_INFO * pDirInfo );
/* fBNgN[Y */
unsigned short RfCloseDir( T_RF_FCB * pFcb  );

#ifdef __cplusplus
}
#endif


#endif /* #define RF_INTERFACE_H */
