/****************************************************************************/
/* T  vF read only t@C݃[hŃI[v				*/
/*   F ㏑[hŃI[văG[ɂȂ邱ƂmF			*/
/* 쐬F 2005.07.17														*/
/* XVF 2014.02.08														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "TraceOut.h"
#include "TstDefine.h"
#include "RfGeneral.h"

#define READ_ONLY_FILE "\\readonly.txt"
#define READ_ONLY_VAL "This is read only file.\n"
#define BUFF_LEN (32L)

static unsigned long bfLen = 0L;

unsigned short gettingReady( void );		/*  */

/****************************************************************************/
/* T  v																	*/
/*        ǂݎp̃eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestReadOnly( void )
{
	unsigned short err;
	T_RF_FCB *pFcb;
	char readBuff[BUFF_LEN];
	unsigned long len = 0L;

	TEST_TITLE(("Test read only."));
	TestReady();

	/*  */
	err = gettingReady();
	if( err != RF_OK )							goto ERR_EXIT;
	
	/* ݃[hŃI[v */
	pFcb = RfOpen( READ_ONLY_FILE, RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_ERR_READ_ONLY, "RfOpen(RF_OPEN_WRITE_OLD) [NG] RF_ERR_READ_ONLY");
	if( pFcb )
	{
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose(RF_OPEN_WRITE_OLD)");
	}

	/* [h */
	pFcb = RfOpen( READ_ONLY_FILE, RF_OPEN_READ, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen(RF_OPEN_READ)");
	if( !pFcb )									goto ERR_EXIT;
	len = bfLen;
	err = RfRead( pFcb, readBuff, &len);
	CHK_ERR_CODE(err, RF_OK, "RfRead()");

	/* er */
	CHK_CMP_STR(READ_ONLY_VAL, readBuff, "read value.");

	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose(RF_OPEN_WRITE_OLD)");

	/* ݂ */
	err = RfSetReadOnly( READ_ONLY_FILE, FALSE );
	CHK_ERR_CODE(err, RF_OK, "RfSetReadOnly()");

	/* ݃[hŃI[v */
	pFcb = RfOpen( READ_ONLY_FILE, RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen(RF_OPEN_WRITE_OLD)");
	if( pFcb )
	{
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose(RF_OPEN_WRITE_OLD)");
	}

ERR_EXIT:
	TestConclude();
	return;
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݎpt@C쐬									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
unsigned short gettingReady( void )
{
	unsigned short err = 0;
	unsigned long len = 0l;
	T_RF_FCB * pFcb;

	/* t@C쐬 */
	pFcb = RfOpen( READ_ONLY_FILE, RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen()");
	if( err != RF_OK )							goto ERR_EXIT;
	if( !pFcb )									goto ERR_EXIT;
	len = (unsigned long)rfStrLen( READ_ONLY_VAL, (int)BUFF_LEN );
	bfLen = len;
	err = RfWrite( pFcb, READ_ONLY_VAL, &len );
	CHK_ERR_CODE(err, RF_OK, "write()");
	CHK_CMP_DEC(bfLen ,len, "diff before write and after.");
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose()");
	
	/* ǂݎpɂ */
	err = RfSetReadOnly( READ_ONLY_FILE, TRUE );
	CHK_ERR_CODE(err, RF_OK, "RfSetReadOnly()");

ERR_EXIT:
	return err;
}
